/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.estate.parknotice.controller;

import cn.hutool.core.codec.Base64;
import cn.hutool.core.codec.Base64Encoder;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.community.agency.entity.Agency;
import org.springblade.community.agency.service.IAgencyService;
import org.springblade.community.residential.entity.Residential;
import org.springblade.community.residential.service.IResidentialService;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.estate.parknotice.entity.Parknotice;
import org.springblade.estate.parknotice.vo.ParknoticeVO;
import org.springblade.estate.parknotice.wrapper.ParknoticeWrapper;
import org.springblade.estate.parknotice.service.IParknoticeService;
import org.springblade.core.boot.ctrl.BladeController;
import sun.misc.BASE64Encoder;

import java.util.List;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2020-12-23
 */
@RestController
@AllArgsConstructor
@RequestMapping("estate/parknotice")
@Api(value = "园区公告接口", tags = "园区公告接口")
public class ParknoticeController extends BladeController {

	private IParknoticeService parknoticeService;
	private IResidentialService residentialService;
	private IAgencyService agencyService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入parknotice")
	public R<ParknoticeVO> detail(Parknotice parknotice) {
		Parknotice detail = parknoticeService.getOne(Condition.getQueryWrapper(parknotice).orderByDesc("create_time"));
		return R.data(ParknoticeWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入parknotice")
	public R<IPage<ParknoticeVO>> list(Parknotice parknotice, Query query,BladeUser bladeUser) {
		if (parknotice.getAgencyId()!=null){
			LambdaQueryWrapper<Parknotice> queryWrapper = new LambdaQueryWrapper<>();
			queryWrapper.and(wrapper -> wrapper.eq(Parknotice::getAgencyId, parknotice.getAgencyId()).or().eq(Parknotice::getType, 2));
			queryWrapper.orderByDesc(Parknotice::getCreateTime);
			IPage<Parknotice> pages = parknoticeService.page(Condition.getPage(query), queryWrapper);
			return R.data(ParknoticeWrapper.build().pageVO(pages));
		}else if(bladeUser.getTenantId().equals("000000")){
			IPage<Parknotice> pages = parknoticeService.page(Condition.getPage(query), Condition.getQueryWrapper(parknotice).orderByDesc("create_time"));
			return R.data(ParknoticeWrapper.build().pageVO(pages));
		}
		else{
			LambdaQueryWrapper<Parknotice> queryWrapper = new LambdaQueryWrapper<>();
			List<Agency> agencyList = agencyService.getBaseMapper().selectList(new QueryWrapper<>(new Agency()).eq("tenant_id",bladeUser.getTenantId()).eq("is_deleted",0));
			queryWrapper.and(wrapper -> wrapper.eq(Parknotice::getAgencyId, agencyList.get(0).getId()).or().eq(Parknotice::getType, 2));
			queryWrapper.orderByDesc(Parknotice::getCreateTime);
			IPage<Parknotice> pages = parknoticeService.page(Condition.getPage(query), queryWrapper);
			return R.data(ParknoticeWrapper.build().pageVO(pages));
		}
	}

	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入parknotice")
	public R<IPage<ParknoticeVO>> page(ParknoticeVO parknotice, Query query) {
		IPage<ParknoticeVO> pages = parknoticeService.selectParknoticePage(Condition.getPage(query), parknotice);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入parknotice")
	public R save(@Valid @RequestBody Parknotice parknotice) {
		parknotice.setNotice(Base64.encode(parknotice.getNotice()));
		return R.status(parknoticeService.save(parknotice));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入parknotice")
	public R update(@Valid @RequestBody Parknotice parknotice) {
		return R.status(parknoticeService.updateById(parknotice));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入parknotice")
	public R submit(@Valid @RequestBody Parknotice parknotice, BladeUser bladeUser) {
		//园区公告：一个账号对应一个tenant_id，使用selectOne
		List<Agency> agencyList = agencyService.getBaseMapper().selectList(new QueryWrapper<>(new Agency()).eq("tenant_id",bladeUser.getTenantId()).ne("is_deleted",1));
		parknotice.setAgencyId(agencyList.get(0).getId());
		return R.status(parknoticeService.saveOrUpdate(parknotice));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(parknoticeService.deleteLogic(Func.toLongList(ids)));
	}


}
